/**
 * Copyright Copyright 2008-14 Simon Andrews
 *
 *    This file is part of FocalPoint.
 *
 *    FocalPoint is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    FocalPoint is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with StackMeasure; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package uk.ac.bbsrc.babraham.FocalPoint.GUI;

import java.awt.BorderLayout;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import uk.ac.bbsrc.babraham.FocalPoint.GUI.Thumbnail.ThumbnailPanel;
import uk.ac.bbsrc.babraham.FocalPoint.GUI.events.IconSizeListener;

public class IconSizeSlider extends JPanel implements ChangeListener {

	private JSlider slider;
	private Vector<IconSizeListener> listeners = new Vector<IconSizeListener>();
	
	public IconSizeSlider () {
		setBorder(BorderFactory.createEmptyBorder(3, 3, 3, 3));
		setLayout(new BorderLayout());
		add(new JLabel("Icon width (pixels)",JLabel.LEFT),BorderLayout.NORTH);
		slider = new JSlider(JSlider.HORIZONTAL,0,500,ThumbnailPanel.thumbnailWidth);
		slider.setLabelTable(slider.createStandardLabels(50));
		slider.setPaintLabels(true);
		slider.addChangeListener(this);
		add(slider,BorderLayout.CENTER);
	}

	public void addListener (IconSizeListener l) {
		if (l != null && ! listeners.contains(l)) {
			listeners.add(l);
		}
	}

	public void removeListener (IconSizeListener l) {
		if (l != null && listeners.contains(l)) {
			listeners.remove(l);
		}
	}
	
	public void stateChanged(ChangeEvent ce) {
		// Don't make a change whilst they're still dragging
		if (!slider.getValueIsAdjusting()) {
			Enumeration<IconSizeListener> e = listeners.elements();
			while (e.hasMoreElements()) {
				e.nextElement().setNewIconSize(slider.getValue());
			}
		}
		
	}
	
}
